'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var mappings = {
  '[': "\u0907",
  ']': "\u090F",
  '{': "\u0908",
  '}': "\u0910",
  '|': "\u0903",
  '/': "\u094D",
  '\\': "\u0950",
  _: "\u0952",
  '+': "\u200C",
  '=': "\u200D",
  '<': "\u0919",
  '>': "\u0965",
  '.': "\u0964",
  '`': "\u093D",
  '~': "\u093C",
  0: "\u0966",
  1: "\u0967",
  2: "\u0968",
  3: "\u0969",
  4: "\u096A",
  5: "\u096B",
  6: "\u096C",
  7: "\u096D",
  8: "\u096E",
  9: "\u096F",
  a: "\u093E",
  b: "\u092C",
  c: "\u091B",
  d: "\u0926",
  e: "\u0947",
  f: "\u0909",
  g: "\u0917",
  h: "\u0939",
  i: "\u093F",
  j: "\u091C",
  k: "\u0915",
  l: "\u0932",
  m: "\u092E",
  n: "\u0928",
  o: "\u094B",
  p: "\u092A",
  q: "\u091F",
  r: "\u0930",
  s: "\u0938",
  t: "\u0924",
  u: "\u0941",
  v: "\u0935",
  w: "\u094C",
  x: "\u0921",
  y: "\u092F",
  z: "\u0937",
  A: "\u0906",
  B: "\u092D",
  C: "\u091A",
  D: "\u0927",
  E: "\u0948",
  F: "\u090A",
  G: "\u0918",
  H: "\u0905",
  I: "\u0940",
  J: "\u091D",
  K: "\u0916",
  L: "\u0933",
  M: "\u0902",
  N: "\u0923",
  O: "\u0913",
  P: "\u092B",
  Q: "\u0920",
  R: "\u0943",
  S: "\u0936",
  T: "\u0925",
  U: "\u0942",
  V: "\u0901",
  W: "\u0914",
  X: "\u0922",
  Z: "\u090B",
  Y: "\u091E"
};

var BiMap = /*#__PURE__*/function () {
  function BiMap(map) {
    var _this = this;

    this.map = map;
    this.reverseMap = new Map();
    map.forEach(function (value, key) {
      _this.reverseMap.set(value, key);
    });
  }

  var _proto = BiMap.prototype;

  _proto.get = function get(key) {
    return this.map.get(key);
  };

  _proto.rGet = function rGet(key) {
    return this.reverseMap.get(key);
  };

  return BiMap;
}();
var NepaliUnicodeMap = /*#__PURE__*/new BiMap( /*#__PURE__*/new Map( /*#__PURE__*/Object.entries(mappings)));
function getNepaliFromEnglish(text) {
  return text.split('').reduce(function (acc, cur) {
    return acc += NepaliUnicodeMap.get(cur) || cur;
  }, '');
}
function getEnglishFromNepali(text) {
  return text.split('').reduce(function (acc, cur) {
    return acc += NepaliUnicodeMap.rGet(cur) || cur;
  }, '');
}

var _excluded = ["onChange", "type"],
    _excluded2 = ["onChange"];

function internalChangeHandler(e, ref, internalRef, onChange) {
  var nepaliTextFromEnglish = getNepaliFromEnglish(e.target.value);

  if (ref && typeof ref !== 'function') {
    if (ref.current) {
      ref.current.value = nepaliTextFromEnglish;
    }
  } else {
    if (internalRef.current) {
      internalRef.current.value = nepaliTextFromEnglish;
    }
  }

  if (onChange) {
    onChange(_extends({}, e, {
      target: _extends({}, e.target, {
        value: nepaliTextFromEnglish
      })
    }));
  }
}

var NepaliInput = /*#__PURE__*/React.forwardRef(function TextMaskCustom(props, ref) {
  var _onChange = props.onChange,
      rest = _objectWithoutPropertiesLoose(props, _excluded);

  var internalRef = React.useRef(null);
  return React.createElement("input", Object.assign({}, rest, {
    ref: ref || internalRef,
    onChange: function onChange(e) {
      return internalChangeHandler(e, ref, internalRef, _onChange);
    }
  }));
});
var NepaliTextArea = /*#__PURE__*/React.forwardRef(function TextMaskCustom(props, ref) {
  var _onChange2 = props.onChange,
      rest = _objectWithoutPropertiesLoose(props, _excluded2);

  var internalRef = React.useRef(null);
  return React.createElement("textarea", Object.assign({}, rest, {
    ref: ref || internalRef,
    onChange: function onChange(e) {
      return internalChangeHandler(e, ref, internalRef, _onChange2);
    }
  }));
});

exports.NepaliInput = NepaliInput;
exports.NepaliTextArea = NepaliTextArea;
exports.getEnglishFromNepali = getEnglishFromNepali;
exports.getNepaliFromEnglish = getNepaliFromEnglish;
exports.mappings = mappings;
//# sourceMappingURL=nepali-input-react.cjs.development.js.map
